// C6X_CONTROLDlg.cpp : implementation file
//

#include "stdafx.h"
#include "C6X_CONTROL.h"
#include "C6X_CONTROLDlg.h"

#include "math.h"
#include "C6XCONTROL_DLL.h"
#include "afxwin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	virtual BOOL OnInitDialog();
	DECLARE_MESSAGE_MAP()
public:
	CEdit m_VersionText;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_About_VersionText, m_VersionText);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	char s[64];
	unsigned long version;

	version = C6XCONTROL_getVersion();
	sprintf_s(s,64,"Based on winDSK6 Kernel Version %d.%d.%d.%d", 
		(version >> 24) & 0xFF,
		(version >> 16) & 0xFF,
		(version >>  8) & 0xFF,
		(version      ) & 0xFF);
	m_VersionText.SetWindowText(s);

	return TRUE;   // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}



// CC6X_CONTROLDlg dialog




CC6X_CONTROLDlg::CC6X_CONTROLDlg(CWnd* pParent /*=NULL*/)
: CDialog(CC6X_CONTROLDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CC6X_CONTROLDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER1, m_GainSlider);
}

BEGIN_MESSAGE_MAP(CC6X_CONTROLDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CC6X_CONTROLDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CC6X_CONTROLDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_ResetDsk, &CC6X_CONTROLDlg::OnBnClickedResetdsk)
	ON_BN_CLICKED(IDC_RunDsk, &CC6X_CONTROLDlg::OnBnClickedRundsk)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER1, &CC6X_CONTROLDlg::OnNMReleasedcaptureSlider1)
END_MESSAGE_MAP()


// CC6X_CONTROLDlg message handlers

BOOL CC6X_CONTROLDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// *****************************************************************************
	// begin DSK specific initialization code
	// *****************************************************************************

	// initialize the DSK interface software
	if(!C6XCONTROL_StartUp()) {				// do dsk object port driver initialization
		if(AfxMessageBox("Parallel port operations will fail if attempted - do you wish to continue anyway?",MB_YESNO) != IDYES) {
			EndDialog(IDCANCEL);
			return TRUE;
		}
	}


	// *****************************************************************************
	// set up DSK configuration 

	// C6211 DSK
	//	C6XCONTROL_setDSP(C6211);
	//	C6XCONTROL_setLptPort(LPT1, SPP_NIBBLE_MODE);

	// C6711 DSK
	//	C6XCONTROL_setDSP(C6711);
	//	C6XCONTROL_setLptPort(LPT1, SPP_NIBBLE_MODE);

	// C713 DSK using parallel port interface
	//	C6XCONTROL_setDSP(C6713_LPT);
	//	C6XCONTROL_setLptPort(LPT1, SPP_NIBBLE_MODE);

	// C713 DSK using serial port interface
	//	C6XCONTROL_setDSP(C6713_COM);
	//	C6XCONTROL_setComPort(COM1, COM_RS232);

	// C713 DSK using USB interface
	C6XCONTROL_setDSP(C6713_COM);
	C6XCONTROL_setComPort(COM5, COM_USB2); // set to COM port used by USB driver

	// C416T DSK using parallel port interface
	//	C6XCONTROL_setDSP(C6416T_LPT);
	//	C6XCONTROL_setLptPort(LPT1, SPP_NIBBLE_MODE);

	// C416T DSK using serial port interface
	//	C6XCONTROL_setDSP(C6416T_COM);
	//	C6XCONTROL_setComPort(COM1, COM_RS232);

	// C416T DSK using USB interface
	//	C6XCONTROL_setDSP(C6416T_COM);
	//	C6XCONTROL_setComPort(COM5, COM_USB2); // set to COM port used by USB driver

	// end DSK specific initialization code
	// *****************************************************************************

	// set up gain slider control
	m_GainSlider.SetRange(0, 100, true);
	m_GainSlider.SetPos(0);
	m_GainSlider.SetTicFreq(10);

	DskIsRunning = false;			// flag DSK as not started yet

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CC6X_CONTROLDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CC6X_CONTROLDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CC6X_CONTROLDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CC6X_CONTROLDlg::OnBnClickedOk()
{
	OnOK();
}

void CC6X_CONTROLDlg::OnBnClickedCancel()
{
	OnCancel();
}

void CC6X_CONTROLDlg::OnBnClickedResetdsk()
{
	DskIsRunning = false;

	if(!C6XCONTROL_ResetDsk()) {
		AfxMessageBox("DSK Reset Failed");
		return;
	}
}

void CC6X_CONTROLDlg::OnBnClickedRundsk()
{
	DskIsRunning = false;
	m_GainSlider.SetPos(0);

	if(!C6XCONTROL_ResetAndRunCOFF(".\\DSP\\talkthru\\release\\talkthru.out", true)) {
		AfxMessageBox("Program Load Failed");
		return;
	}

	// the DSK app is waiting for the codec version to be set
	//	unsigned long temp = TLC320AD535;			// codec_version field for 6211/6711 onboard codec
	unsigned long temp = AIC23_16bit_McBSP01;	// codec_version field for 6713 DSK
	//	unsigned long temp = AIC23_16bit_McBSP12;	// codec_version field for 6416T DSK
	if(!C6XCONTROL_Write(C6XCONTROL_getHPI_BaseAddress() + HPI_Block_CODEC_Offset, 1, &temp)) {
		AfxMessageBox("DSK Write Failed");
		return; // close dialog
	}

	DskIsRunning = true;
}

void CC6X_CONTROLDlg::OnNMReleasedcaptureSlider1(NMHDR *pNMHDR, LRESULT *pResult)
{
	if(DskIsRunning) {	
		double setting = (double)(m_GainSlider.GetPos()) / 4.0; // 0db to -25db adjustment range
		float data = static_cast<float>(pow(10.0, -setting / 20.0));
		if(!C6XCONTROL_WriteFloat(C6XCONTROL_getHPI_BaseAddress() + HPI_Block_Application_Base + 0, 1, &data)) {
			AfxMessageBox("DSK Write Failed");
			return;
		}
	}

	*pResult = 0;
}
